;--------------------------------------------------------
;AutoIt Version: 3.2.4.9
$Script_Author = 'Andrew Calcutt'
$Script_Start_Date = '07/09/2007'
$Script_Name = 'Vistumbler'
$Script_Function = 'A netstumbler like program for vista. This Program uses "netsh wlan show networks mode=bssid" to get wireless information.'
$version = 'v3.2 Beta'
$last_modified = '08/02/2007'
;--------------------------------------------------------
#include <File.au3>
#include <Array.au3>
#Include <process.au3>
#include <GuiConstants.au3>
#Include <GuiListView.au3>
AutoItSetOption('TrayIconHide', 1);Hide icon in system tray

If @OSVersion <> "WIN_VISTA" Then MsgBox(0, "Warning", "This Program will only run in Vista. It relies on a netsh command that is not avalible in older versions of windows")

$tempfile = 'Vistumbler_Temp.txt'
$manufactures = 'manufactures.ini'
Dim $Latitude = 'N 0.0000000'
Dim $Longitude = 'E 0.0000000'
Dim $ScanGPS = 0
Dim $SortList = 0
Dim $Scan = 0
Dim $Exit = 0
Dim $TempFileArray, $OpenArray, $oMyError, $temp, $LatTest, $gps, $NetComm, $CommPort, $msgdisplay, $Sort, $timestamp, $sort_timer, $headers
Dim $SSID, $NetworkType, $Authentication, $Encryption, $BSSID, $Signal, $RadioType, $Channel, $BasicTransferRates, $OtherTransferRates, $display, $ActiveBSSIDs
Dim $Direction[16]

;Load Settings
Dim $settings = 'vistumbler_settings.ini'
Dim $saved_comport = IniRead($settings, 'Vistumbler', 'ComPort', 8)
Dim $saved_baud = IniRead($settings, 'Vistumbler', 'Baud', 4800)
Dim $saved_sleeptime = IniRead($settings, 'Vistumbler', 'Sleeptime', 1)
Dim $saved_autosorttime = IniRead($settings, 'Vistumbler', 'AutoSortTime', 60)
Dim $saved_sortcombo = IniRead($settings, 'Vistumbler', 'SortCombo', 'Sort by SSID')
Dim $saved_asc_dec = IniRead($settings, 'Vistumbler', 'AscDecDefault', 'Decending')
Dim $saved_autosort = IniRead($settings, 'Vistumbler', 'AutoSort', 0)
Dim $SoundOnAP = IniRead($settings, 'Vistumbler', 'PlaySoundOnNewAP', 0)
Dim $new_AP_sound = IniRead($settings, 'Vistumbler', 'NewAP_Sound', 'new.wav')
Dim $column_Active = IniRead($settings, 'Columns', 'Column_Active', 0)
Dim $column_SSID = IniRead($settings, 'Columns', 'Column_SSID', 1)
Dim $column_BSSID = IniRead($settings, 'Columns', 'Column_BSSID', 2)
Dim $column_MANUF = IniRead($settings, 'Columns', 'Column_Manufacturer', 3)
Dim $column_Signal = IniRead($settings, 'Columns', 'Column_Signal', 4)
Dim $column_Authentication = IniRead($settings, 'Columns', 'Column_Authentication', 5)
Dim $column_Encryption = IniRead($settings, 'Columns', 'Column_Encryption', 6)
Dim $column_RadioType = IniRead($settings, 'Columns', 'Column_RadioType', 7)
Dim $column_Channel = IniRead($settings, 'Columns', 'Column_Channel', 8)
Dim $column_Latitude = IniRead($settings, 'Columns', 'Column_Latitude', 9)
Dim $column_Longitude = IniRead($settings, 'Columns', 'Column_Longitude', 10)
Dim $column_BasicTransferRates = IniRead($settings, 'Columns', 'Column_BasicTransferRates', 11)
Dim $column_OtherTransferRates = IniRead($settings, 'Columns', 'Column_OtherTransferRates', 12)
Dim $column_FirstActive = IniRead($settings, 'Columns', 'Column_FirstActive', 50)
Dim $column_LastActive = IniRead($settings, 'Columns', 'Column_LastActive', 50)
Dim $column_NetworkType = IniRead($settings, 'Columns', 'Column_NetworkType', 50)
Dim $column_Width_Active = IniRead($settings, 'Column_Width', 'Column_Active', 50)
Dim $column_Width_SSID = IniRead($settings, 'Column_Width', 'Column_SSID', 50)
Dim $column_Width_BSSID = IniRead($settings, 'Column_Width', 'Column_BSSID', 50)
Dim $column_Width_MANUF = IniRead($settings, 'Column_Width', 'Column_Manufacturer', 50)
Dim $column_Width_Signal = IniRead($settings, 'Column_Width', 'Column_Signal', 50)
Dim $column_Width_Authentication = IniRead($settings, 'Column_Width', 'Column_Authentication', 50)
Dim $column_Width_Encryption = IniRead($settings, 'Column_Width', 'Column_Encryption', 50)
Dim $column_Width_RadioType = IniRead($settings, 'Column_Width', 'Column_RadioType', 50)
Dim $column_Width_Channel = IniRead($settings, 'Column_Width', 'Column_Channel', 50)
Dim $column_Width_Latitude = IniRead($settings, 'Column_Width', 'Column_Latitude', 50)
Dim $column_Width_Longitude = IniRead($settings, 'Column_Width', 'Column_Longitude', 50)
Dim $column_Width_BasicTransferRates = IniRead($settings, 'Column_Width', 'Column_BasicTransferRates', 50)
Dim $column_Width_OtherTransferRates = IniRead($settings, 'Column_Width', 'Column_OtherTransferRates', 50)
Dim $column_Width_FirstActive = IniRead($settings, 'Column_Width', 'Column_FirstActive', 50)
Dim $column_Width_LastActive = IniRead($settings, 'Column_Width', 'Column_LastActive', 50)
Dim $column_Width_NetworkType = IniRead($settings, 'Column_Width', 'Column_NetworkType', 50)
Dim $SearchWord_SSID = IniRead($settings, 'SearchWords', 'SSID', 'SSID')
Dim $SearchWord_BSSID = IniRead($settings, 'SearchWords', 'BSSID', 'BSSID')
Dim $SearchWord_NetworkType = IniRead($settings, 'SearchWords', 'NetworkType', 'Network type')
Dim $SearchWord_Authentication = IniRead($settings, 'SearchWords', 'Authentication', 'Authentication')
Dim $SearchWord_Encryption = IniRead($settings, 'SearchWords', 'Encryption', 'Encryption')
Dim $SearchWord_Signal = IniRead($settings, 'SearchWords', 'Signal', 'Signal')
Dim $SearchWord_RadioType = IniRead($settings, 'SearchWords', 'RadioType', 'Radio Type')
Dim $SearchWord_Channel = IniRead($settings, 'SearchWords', 'Channel', 'Channel')
Dim $SearchWord_BasicRates = IniRead($settings, 'SearchWords', 'BasicRates', 'Basic Rates')
Dim $SearchWord_OtherRates = IniRead($settings, 'SearchWords', 'OtherRates', 'Other Rates')

Dim $manu_mac[1], $manu_manu[1]

;Create array of manufacturers
$var = IniReadSection($settings, "MANUFACURERS")
If @error Then
	MsgBox(4096, "", "Error occurred, probably no INI file.")
Else
	For $i = 1 To $var[0][0]
		_ArrayAdd($manu_mac, $var[$i][0])
		_ArrayAdd($manu_manu, $var[$i][1])
	Next
	$manu_mac[0] = UBound($manu_mac) - 1
	$manu_manu[0] = UBound($manu_manu) - 1
EndIf

;Set up column header order based on INI file
$var = IniReadSection($settings, "Columns")
If @error Then
	$headers = 'Active|SSID|BSSID|Manufacturer|Signal|Authentication|Encryption|Radio Type|Channel|Latitude|Longitude|Basic Transfer Rates|Other Transfer Rates|First Active|Last Active|Network Type'
Else
	For $a = 0 To ($var[0][0] - 1)
		For $b = 1 To $var[0][0]
			If $a = $var[$b][1] Then $headers &= IniRead($settings, 'Column_Names', $var[$b][0], '') & '|'
		Next
	Next
EndIf



;-------------------------------------------------------------------------------------------------------------------------------
;                                                       GUI
;-------------------------------------------------------------------------------------------------------------------------------

Opt("GUIOnEventMode", 1)  ; Change to OnEvent mode
$Vistumbler_GUI = GUICreate($Script_Name & ' ' & $version & ' - By Andrew Calcutt' & ' - ' & $last_modified, 875, 604, -1, -1, BitOR($WS_OVERLAPPEDWINDOW, $WS_CLIPSIBLINGS))
$AccessPointList = GUICtrlCreateListView($headers, 0, 90, 873, 510, $LVS_REPORT, $LVS_EX_HEADERDRAGDROP + $LVS_EX_GRIDLINES + $LVS_EX_FULLROWSELECT)

$ScanButton = GUICtrlCreateButton("Scan", 10, 8, 65, 20, 0)
$Load = GUICtrlCreateButton("Load From TXT", 75, 8, 80, 20, 0)
$SaveButton = GUICtrlCreateButton("Save As TXT", 155, 8, 80, 20, 0)
$SaveKML = GUICtrlCreateButton("Save As KML", 235, 8, 80, 20, 0)
$RefLoopLabel = GUICtrlCreateLabel("Refresh Loop Time(mS):", 328, 8, 118, 20)
$sleeptime = GUICtrlCreateInput($saved_sleeptime, 448, 8, 49, 21)
$timediff = GUICtrlCreateLabel("Actual Loop Time(mS):", 504, 8, 200, 20)
$ActiveAPs = GUICtrlCreateLabel("Active APs:", 710, 8, 120, 20)

$UseGPS = GUICtrlCreateCheckbox("Use GPS", 10, 35, 65, 20)
GUICtrlCreateLabel("COM:", 95, 40, 30, 20)
$ComPort = GUICtrlCreateCombo("1", 125, 35, 40, 21)
GUICtrlSetData(-1, "2|3|4|5|6|7|8|9|10|11|12|13|14|15|16|17|18|19|20", $saved_comport)
GUICtrlCreateLabel("Baud:", 170, 40, 35, 20,)
$BAUD = GUICtrlCreateCombo("4800", 200, 35, 100, 25)
GUICtrlSetData(-1, "9600|14400|19200|38400|57600|115200", $saved_baud)
$GuiLat = GUICtrlCreateLabel("", 320, 35, 130, 20)
$GuiLon = GUICtrlCreateLabel("", 450, 35, 130, 20)
$msgdisplay = GUICtrlCreateLabel("", 580, 35, 250, 20)

$AutoSort = GUICtrlCreateCheckbox("Auto Sort", 10, 60, 65, 20)
$SortCombo = GUICtrlCreateCombo('Sort By SSID', 95, 60, 170, 20)
GUICtrlSetData(-1, 'Sort By Network Type|Sort By Authentication|Sort By Encryption|Sort By BSSID|Sort By Signal|Sort By Radio Type|Sort By Channel|Sort By Basic Transfer Rates|Sort By Other Transfer Rates|Sort By Latitude|Sort By Longitude|Sort By First Active|Sort By Last Active|Sort By Active|Sort By Manufacturer', $saved_sortcombo)
$SortAscDec = GUICtrlCreateCombo('Ascending', 275, 60, 80, 20)
GUICtrlSetData(-1, 'Decending', $saved_asc_dec)

If $saved_autosort = 1 Then
	GUICtrlSetState($AutoSort, $GUI_CHECKED)
	_AutoSort()
EndIf
GUICtrlCreateLabel("Auto Sort Every:", 365, 65, 80, 20)
$AutoSortTime = GUICtrlCreateInput($saved_autosorttime, 450, 60, 40, 21)
GUICtrlCreateLabel("Seconds", 495, 65, 50, 20)

$PlaySound = GUICtrlCreateCheckbox("Play sound on new AP", 560, 60, 140, 20)
If $SoundOnAP = 1 Then GUICtrlSetState($PlaySound, $GUI_CHECKED)

;Button Events
GUISetOnEvent($GUI_EVENT_CLOSE, "CLOSEClicked")
GUICtrlSetOnEvent($ScanButton, "ScanToggle")
GUICtrlSetOnEvent($UseGPS, "_GpsToggle")
GUICtrlSetOnEvent($SaveButton, "SaveList")
GUICtrlSetOnEvent($Load, "LoadList")
GUICtrlSetOnEvent($SaveKML, "SaveToKML")
GUICtrlSetOnEvent($AutoSort, "_AutoSort")
GUICtrlSetOnEvent($AccessPointList, "_HeaderSort")

;Set column widths - All variables have ' - 0' after them to make this work. it would not set column widths without the ' - 0'
_GUICtrlListViewSetColumnWidth($AccessPointList, $column_Active - 0, $column_Width_Active - 0)
_GUICtrlListViewSetColumnWidth($AccessPointList, $column_SSID - 0, $column_Width_SSID - 0)
_GUICtrlListViewSetColumnWidth($AccessPointList, $column_BSSID - 0, $column_Width_BSSID - 0)
_GUICtrlListViewSetColumnWidth($AccessPointList, $column_MANUF - 0, $column_Width_MANUF - 0)
_GUICtrlListViewSetColumnWidth($AccessPointList, $column_Signal - 0, $column_Width_Signal - 0)
_GUICtrlListViewSetColumnWidth($AccessPointList, $column_Authentication - 0, $column_Width_Authentication - 0)
_GUICtrlListViewSetColumnWidth($AccessPointList, $column_Encryption - 0, $column_Width_Encryption - 0)
_GUICtrlListViewSetColumnWidth($AccessPointList, $column_RadioType - 0, $column_Width_RadioType - 0)
_GUICtrlListViewSetColumnWidth($AccessPointList, $column_Channel - 0, $column_Width_Channel - 0)
_GUICtrlListViewSetColumnWidth($AccessPointList, $column_Latitude - 0, $column_Width_Latitude - 0)
_GUICtrlListViewSetColumnWidth($AccessPointList, $column_Longitude - 0, $column_Width_Longitude - 0)
_GUICtrlListViewSetColumnWidth($AccessPointList, $column_BasicTransferRates - 0, $column_Width_BasicTransferRates - 0)
_GUICtrlListViewSetColumnWidth($AccessPointList, $column_OtherTransferRates - 0, $column_Width_OtherTransferRates - 0)
_GUICtrlListViewSetColumnWidth($AccessPointList, $column_FirstActive - 0, $column_Width_FirstActive - 0)
_GUICtrlListViewSetColumnWidth($AccessPointList, $column_LastActive - 0, $column_Width_LastActive - 0)
_GUICtrlListViewSetColumnWidth($AccessPointList, $column_NetworkType - 0, $column_Width_NetworkType - 0)

GUISetState(@SW_SHOW)
;-------------------------------------------------------------------------------------------------------------------------------
;                                                       PROGRAM RUNNING LOOP
;-------------------------------------------------------------------------------------------------------------------------------

$refresh_gps = TimerInit() ;Start timer for gps refresh
While 1
	$begin = TimerInit() ;Start $begin timer, used to measure loop time
	If $Scan = 1 Or $ScanGPS = 1 Then
		If $ScanGPS = 1 Then ; If 'Use GPS' is checked then scan gps and display information
			_GetGPS();Scan for GPS if GPS enabled
			_GpsPositionReset(60000);Reset GPS location to $Latitude = 'N 0.0000000' $Longitude = 'E 0.0000000' if new GPS position not found within timeout _GpsPositionReset($timeout)
			GUICtrlSetData($msgdisplay, 'Seconds Since GPS Update: ' & Round(TimerDiff($refresh_gps) / 1000) & '/60');Set how long since GPS update in GUI
			GUICtrlSetData($GuiLat, 'Latitude: ' & $Latitude);Set GPS Latitude in GUI
			GUICtrlSetData($GuiLon, 'Longitude: ' & $Longitude);Set GPS Longitude in GUI
		Else
			GUICtrlSetData($msgdisplay, '') ;Clear Message
		EndIf
		If $Scan = 1 Then _ScanAccessPoints();Scan for Access Points if scanning enabled
		_SetActiveAccessPoints_SetManufacturer();Reset non-active access points; Set 'Active APs' in GUI
		If $SortList = 1 And TimerDiff($sort_timer) >= (GUICtrlRead($AutoSortTime) * 1000) Then _Sort(GUICtrlRead($SortCombo))
		$time = TimerDiff($begin)
		If TimerDiff($begin) <= GUICtrlRead($sleeptime) Then Sleep(GUICtrlRead($sleeptime) - TimerDiff($begin)); If time difference is less then time taken for loop, sleep remaining time
	Else
		$time = TimerDiff($begin)
		Sleep(100)
	EndIf
	GUICtrlSetData($timediff, 'Actual Loop Time: ' & Round($time) & ' / ' & Round(TimerDiff($begin)) & 'mS'); Set 'Actual Loop Time' in GUI
WEnd

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       WIFI SCAN FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------

Func _ScanAccessPoints()
	$basetimestamp = @MON & '-' & @MDAY & '-' & @YEAR & ' ' & @HOUR & ':' & @MIN & ':' & @SEC
	$timestamp_timer = TimerInit()
	_RunDOS("netsh wlan show networks mode=bssid > " & $tempfile) ;copy the output of the 'netsh wlan show networks mode=bssid' command to the temp file
	_FileReadToArray($tempfile, $TempFileArray);read the tempfile into the '$TempFileArray' Araay
	FileDelete($tempfile)
	For $loop = 1 To $TempFileArray[0]; loop through the temp file array
		If StringInStr($TempFileArray[$loop], $SearchWord_SSID) Then
			Dim $SSID = '', $NetworkType = '', $Authentication = '', $Encryption = '', $BSSID = '', $Signal = '', $RadioType = '', $Channel = '', $BasicTransferRates = '', $OtherTransferRates = '', $MANUF ;Clear Variables
			While StringInStr($TempFileArray[$loop + 1], $SearchWord_SSID) <> 1
				$temp = StringSplit($TempFileArray[$loop], ":")
				If IsArray($temp) Then ; Strip Data from line
					If StringInStr($temp[1], $SearchWord_BSSID) Then
						$BSSID = StringStripWS(StringUpper($temp[2] & ':' & $temp[3] & ':' & $temp[4] & ':' & $temp[5] & ':' & $temp[6] & ':' & $temp[7]), 3)
						;$MANUF = _FindManufacturer($temp[2] & $temp[3] & $temp[4])
					ElseIf StringInStr($temp[1], $SearchWord_SSID) Then
						$SSID = StringStripWS($temp[2], 3)
					ElseIf StringInStr($temp[1], $SearchWord_NetworkType) Then
						$NetworkType = StringStripWS($temp[2], 3)
					ElseIf StringInStr($temp[1], $SearchWord_Authentication) Then
						$Authentication = StringStripWS($temp[2], 3)
					ElseIf StringInStr($temp[1], $SearchWord_Encryption) Then
						$Encryption = StringStripWS($temp[2], 3)
					ElseIf StringInStr($temp[1], $SearchWord_Signal) Then
						$Signal = StringStripWS($temp[2], 3)
					ElseIf StringInStr($temp[1], $SearchWord_RadioType) Then
						$RadioType = StringStripWS($temp[2], 3)
					ElseIf StringInStr($temp[1], $SearchWord_Channel) Then
						$Channel = StringStripWS($temp[2], 3)
					ElseIf StringInStr($temp[1], $SearchWord_BasicRates) Then
						$BasicTransferRates = StringStripWS($temp[2], 3)
					ElseIf StringInStr($temp[1], $SearchWord_OtherRates) Then
						$OtherTransferRates = StringStripWS($temp[2], 3)
					EndIf
				EndIf

				If ($loop + 1) >= $TempFileArray[0] Then ExitLoop ;If Adding 1 to the loop will make it greater than the array size, ExitLoop so no crash happens
				$loop += 1
			WEnd
			If $BSSID <> '' Then ; If Mac Address(BSSID) was found write data into
				;$timestamp = $basetimestamp & ':' & Round((TimerDiff($timestamp_timer) / 1000) * 60)
				$timestamp = $basetimestamp & ' ' & Round((TimerDiff($timestamp_timer))) & ''
				$arraysearch = -1
				$itemcount = _GUICtrlListViewGetItemCount($AccessPointList)
				For $findloop = 0 To $itemcount; Find BSSID in existing list
					If _GUICtrlListViewGetItemText($AccessPointList, $itemcount - $findloop, $column_BSSID) = $BSSID And _GUICtrlListViewGetItemText($AccessPointList, $itemcount - $findloop, $column_SSID) = $SSID Then
						$arraysearch = $itemcount - $findloop
						ExitLoop
					EndIf
				Next

				If $arraysearch = -1 Then ;If BSSID is not found, add it - Else - Update old entry
					;GUICtrlCreateListViewItem('Active' & '|' & $SSID & '|' & $BSSID & '|' & $MANUF & '|' & $Signal & '|' & $Authentication & '|' & $Encryption & '|' & $RadioType & '|' & $Channel & '|' & $Latitude & '|' & $Longitude & '|' & $BasicTransferRates & '|' & $OtherTransferRates & '|' & $timestamp & '|' & $timestamp & '|' & $NetworkType, $AccessPointList)
					$new = _GUICtrlListViewInsertItem($AccessPointList, -1, '')
					_GUICtrlListViewSetItemText($AccessPointList, $new, $column_Active, "Active")
					_GUICtrlListViewSetItemText($AccessPointList, $new, $column_SSID, $SSID)
					_GUICtrlListViewSetItemText($AccessPointList, $new, $column_BSSID, $BSSID)
					_GUICtrlListViewSetItemText($AccessPointList, $new, $column_MANUF, '')
					_GUICtrlListViewSetItemText($AccessPointList, $new, $column_Signal, $Signal)
					_GUICtrlListViewSetItemText($AccessPointList, $new, $column_Authentication, $Authentication)
					_GUICtrlListViewSetItemText($AccessPointList, $new, $column_Encryption, $Encryption)
					_GUICtrlListViewSetItemText($AccessPointList, $new, $column_RadioType, $RadioType)
					_GUICtrlListViewSetItemText($AccessPointList, $new, $column_Channel, $Channel)
					_GUICtrlListViewSetItemText($AccessPointList, $new, $column_Latitude, $Latitude)
					_GUICtrlListViewSetItemText($AccessPointList, $new, $column_Longitude, $Longitude)
					_GUICtrlListViewSetItemText($AccessPointList, $new, $column_BasicTransferRates, $BasicTransferRates)
					_GUICtrlListViewSetItemText($AccessPointList, $new, $column_OtherTransferRates, $OtherTransferRates)
					_GUICtrlListViewSetItemText($AccessPointList, $new, $column_FirstActive, $timestamp)
					_GUICtrlListViewSetItemText($AccessPointList, $new, $column_LastActive, $timestamp)
					_GUICtrlListViewSetItemText($AccessPointList, $new, $column_NetworkType, $NetworkType)
					If GUICtrlRead($PlaySound) = 1 Then SoundPlay($new_AP_sound, 0)
				Else
					_GUICtrlListViewSetItemText($AccessPointList, $arraysearch, $column_Active, "Active")
					_GUICtrlListViewSetItemText($AccessPointList, $arraysearch, $column_SSID, $SSID)
					_GUICtrlListViewSetItemText($AccessPointList, $arraysearch, $column_BSSID, $BSSID)
					;_GUICtrlListViewSetItemText($AccessPointList, $arraysearch, $column_MANUF, $MANUF)
					_GUICtrlListViewSetItemText($AccessPointList, $arraysearch, $column_Signal, $Signal)
					_GUICtrlListViewSetItemText($AccessPointList, $arraysearch, $column_Authentication, $Authentication)
					_GUICtrlListViewSetItemText($AccessPointList, $arraysearch, $column_Encryption, $Encryption)
					_GUICtrlListViewSetItemText($AccessPointList, $arraysearch, $column_RadioType, $RadioType)
					_GUICtrlListViewSetItemText($AccessPointList, $arraysearch, $column_Channel, $Channel)
					If $Latitude <> 'N 0.0000000' And $Latitude <> '' Then _GUICtrlListViewSetItemText($AccessPointList, $arraysearch, $column_Latitude, $Latitude)
					If $Longitude <> 'E 0.0000000' And $Longitude <> '' Then _GUICtrlListViewSetItemText($AccessPointList, $arraysearch, $column_Longitude, $Longitude)
					_GUICtrlListViewSetItemText($AccessPointList, $arraysearch, $column_BasicTransferRates, $BasicTransferRates)
					_GUICtrlListViewSetItemText($AccessPointList, $arraysearch, $column_OtherTransferRates, $OtherTransferRates)
					;_GUICtrlListViewSetItemText($AccessPointList, $arraysearch, $column_FirstActive, $timestamp)
					_GUICtrlListViewSetItemText($AccessPointList, $arraysearch, $column_LastActive, $timestamp)
					_GUICtrlListViewSetItemText($AccessPointList, $arraysearch, $column_NetworkType, $NetworkType)
					
				EndIf
				$ActiveBSSIDs &= $BSSID & '|' ; Add found BSSID into $ActiveBSSIDs string for use later displaying Active BSSIDs at end of file read
			EndIf
		EndIf
	Next
EndFunc   ;==>_ScanAccessPoints

Func _SetActiveAccessPoints_SetManufacturer()
	$Active_BSSID_Array = StringSplit($ActiveBSSIDs, '|');Create an array of access points that have just been found
	GUICtrlSetData($ActiveAPs, 'Active APs: ' & ($Active_BSSID_Array[0] - 1) & ' / ' & _GUICtrlListViewGetItemCount($AccessPointList));Display AP totals in GUI (active APs / total APs)
	$ActiveBSSIDs = '';Reset $ActiveBSSIDs for use in next search
	For $active = 0 To _GUICtrlListViewGetItemCount($AccessPointList);Go though all rows in the list
		$foundactive = 0;Reset active flag
		For $activearrayloop = 1 To ($Active_BSSID_Array[0] - 1);Go though found active points and mark them as active in the list
			If $Active_BSSID_Array[$activearrayloop] = _GUICtrlListViewGetItemText($AccessPointList, $active, $column_BSSID) Then ;If the active BSSID is in the column being checked, leave it alone (it should already be set active)
				$foundactive = 1; Set active flag to 1, BSSID being searched for has been found
				ExitLoop
			EndIf
		Next
		If $foundactive = 0 Then _GUICtrlListViewSetItemText($AccessPointList, $active, $column_Active, "Dead");If this row did not have and active BSSID, mark it as 'Dead'
		
		If _GUICtrlListViewGetItemText($AccessPointList, $active, $column_MANUF) = '' Then ;If the Manufacturer column is empty, set manufactuere
			$BSSID = StringReplace(_GUICtrlListViewGetItemText($AccessPointList, $active, $column_BSSID), ':', '') ;Remove ':'s out of the BSSID and set as $BSSID
			_GUICtrlListViewSetItemText($AccessPointList, $active, $column_MANUF, _FindManufacturer(StringTrimRight($BSSID, StringLen($BSSID) - 6)));Set the Manufacturer in the GUI. Finf Manufacturer based on the first six chars of the BSSID
		EndIf
	Next
EndFunc   ;==>_SetActiveAccessPoints_SetManufacturer

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       GPS FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------

Func _OpenComPort($CommPort = '8', $sBAUD = '4800', $s1 = 'N', $s2 = '8', $s3 = '1')
	$CommSettings = $sBAUD & ',' & $s1 & ',' & $s2 & ',' & $s3
	;	Create NETComm.ocx object
	$NetComm = ObjCreate("NETCommOCX.NETComm")
	If IsObj($NetComm) = 0 Then ;If $NetComm is not an object then netcomm ocx is probrably not installed
		MsgBox(0, '', 'Install Netcomm OCX')
	Else
		With $NetComm ;Set object settings
			.CommPort = $CommPort ;Set port number
			.Settings = $CommSettings ;Set port settings
			.InputLen = 0 ;reads entire buffer
			.InputMode = 0 ;reads in text mode
			.HandShaking = 3 ;uses both RTS and Xon/Xoff handshaking
			.PortOpen = "True"
		EndWith
	EndIf
EndFunc   ;==>_OpenComPort

Func _CloseComPort($CommPort = '8')
	;Close the COM Port
	With $NetComm
		.CommPort = $CommPort ;Set port number
		.PortOpen = "False" ;Closes specified COM port
	EndWith
EndFunc   ;==>_CloseComPort

Func _GpsPositionReset($timeout = 60000)
	If TimerDiff($refresh_gps) > $timeout Then ;Reset Position to default if a new location has not been found within timeout period
		$Latitude = 'N 0.0000000'
		$Longitude = 'E 0.0000000'
		$refresh_gps = TimerInit()
	EndIf
EndFunc   ;==>_GpsPositionReset

Func _GetGPS()
	$LatTest = 0
	$timeout = TimerInit()
	While 1 ;Loop to extract gps data untill location is found or timout time is reached
		$maxtime = GUICtrlRead($sleeptime) * 0.8
		If $maxtime < 800 Then $maxtime = 800
		
		$Buffer = $NetComm.InBufferCount
		If $Buffer > 100 And $LatTest = 0 And TimerDiff($timeout) < $maxtime Then
			$inputdata = $NetComm.inputdata
			$gps = StringSplit($inputdata, "$")
			For $readloop = 1 To $gps[0]
				If StringInStr($gps[$readloop], "GPGGA") Then
					_GetGpsData($gps[$readloop])
					If $LatTest = 1 Then ExitLoop
					If TimerDiff($timeout) > $maxtime Then ExitLoop
				EndIf
			Next
			If $LatTest = 1 Then
				$refresh_gps = TimerInit()
				ExitLoop
			EndIf
		EndIf

		If TimerDiff($timeout) > $maxtime Then
			GUICtrlSetData($msgdisplay, 'GPS Timeout')
			ExitLoop
		EndIf
		Sleep($maxtime / 100)
	WEnd
EndFunc   ;==>_GetGPS

Func _GetGpsData($GpsData) ;Read GPS Receiver Data
	GUICtrlSetData($msgdisplay, $GpsData)
	$data = StringSplit($GpsData, ",")
	If $data[0] > 9 Then
		$lat = StringSplit($data[3], ".")
		$lon = StringSplit($data[5], ".")
		If _ArrayMax($lat, 0, 1) >= 2 And _ArrayMax($lat, 0, 1) >= 2 Then
			;Convert to Min/Sec to Decimal Latitude
			$latD = StringMid((StringRight($lat[1], 2) & "." & StringRight($lat[2], 4)) / 60, 2, 10)
			;Convert to Min/Sec to Decimal Longitude
			$lonD = StringMid((StringRight($lon[1], 2) & "." & StringRight($lon[2], 4)) / 60, 2, 10)
			;Set Location Variables
			$ufLat = StringLeft($lat[1], StringLen($lat[1]) - 2) & $latD
			$ufLon = StringLeft($lon[1], StringLen($lon[1]) - 2) & $lonD
			$Latitude = $data[4] & ' ' & StringFormat('%0.7f', $ufLat);set latitude
			$Longitude = $data[6] & ' ' & StringFormat('%0.7f', $ufLon);set longitude
			If $Latitude <> '' Then $LatTest = 1
		EndIf
	EndIf
EndFunc   ;==>_GetGpsData

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       SORT/MANUFACTURER FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------
Func _HeaderSort ()
	$column = GUICtrlGetState($AccessPointList)
	
	If $Direction[$column] = 'Ascending' Then
		Dim $v_sort = _GUICtrlListViewGetSubItemsCount($AccessPointList)
	Else 
		Dim $v_sort[_GUICtrlListViewGetSubItemsCount($AccessPointList) ]
	EndIf
	
	If $Direction[$column] = 'Ascending' Then 
		$Direction[$column] = 'Decending'
	Else
		$Direction[$column] = 'Ascending'
	EndIf
	
	_GUICtrlListViewSort($AccessPointList, $v_sort, $column)
EndFunc   ;==>_HeaderSort


Func _Sort($Sort)

	If GUICtrlRead($SortAscDec) = 'Decending' Then
		Dim $v_sort[_GUICtrlListViewGetSubItemsCount($AccessPointList) ]
	Else ;Ascending
		Dim $v_sort = _GUICtrlListViewGetSubItemsCount($AccessPointList)
	EndIf
	
	If $Sort = 'Sort By SSID' Then
		_GUICtrlListViewSort($AccessPointList, $v_sort, $column_SSID)
	ElseIf $Sort = 'Sort By Network Type' Then
		_GUICtrlListViewSort($AccessPointList, $v_sort, $column_NetworkType)
	ElseIf $Sort = 'Sort By Authentication' Then
		_GUICtrlListViewSort($AccessPointList, $v_sort, $column_Authentication)
	ElseIf $Sort = 'Sort By Encryption' Then
		_GUICtrlListViewSort($AccessPointList, $v_sort, $column_Encryption)
	ElseIf $Sort = 'Sort By BSSID' Then
		_GUICtrlListViewSort($AccessPointList, $v_sort, $column_BSSID)
	ElseIf $Sort = 'Sort By Signal' Then
		_GUICtrlListViewSort($AccessPointList, $v_sort, $column_Signal)
	ElseIf $Sort = 'Sort By Radio Type' Then
		_GUICtrlListViewSort($AccessPointList, $v_sort, $column_RadioType)
	ElseIf $Sort = 'Sort By Channel' Then
		_GUICtrlListViewSort($AccessPointList, $v_sort, $column_Channel)
	ElseIf $Sort = 'Sort By Basic Transfer Rates' Then
		_GUICtrlListViewSort($AccessPointList, $v_sort, $column_BasicTransferRates)
	ElseIf $Sort = 'Sort By Other Transfer Rates' Then
		_GUICtrlListViewSort($AccessPointList, $v_sort, $column_OtherTransferRates)
	ElseIf $Sort = 'Sort By Latitude' Then
		_GUICtrlListViewSort($AccessPointList, $v_sort, $column_Longitude)
	ElseIf $Sort = 'Sort By Longitude' Then
		_GUICtrlListViewSort($AccessPointList, $v_sort, $column_Latitude)
	ElseIf $Sort = 'Sort By First Active' Then
		_GUICtrlListViewSort($AccessPointList, $v_sort, $column_FirstActive)
	ElseIf $Sort = 'Sort By Last Active' Then
		_GUICtrlListViewSort($AccessPointList, $v_sort, $column_LastActive)
	ElseIf $Sort = 'Sort By Active' Then
		_GUICtrlListViewSort($AccessPointList, $v_sort, $column_Active)
	ElseIf $Sort = 'Sort By Manufacturer' Then
		_GUICtrlListViewSort($AccessPointList, $v_sort, $column_MANUF)
	EndIf
	$sort_timer = TimerInit()
EndFunc   ;==>_Sort

Func _FindManufacturer($findmac)
	Dim $return = 'Unknown'
	For $searchmaclist = 1 To $manu_mac[0]
		If StringStripWS(StringUpper($manu_mac[$searchmaclist]), 3) = StringStripWS(StringUpper($findmac), 3) Then
			$return = $manu_manu[$searchmaclist]
			ExitLoop
		EndIf
	Next
	Return ($return)
EndFunc   ;==>_FindManufacturer

;-------------------------------------------------------------------------------------------------------------------------------
;                                                       BUTTON FUNCTIONS
;-------------------------------------------------------------------------------------------------------------------------------

Func _AutoSort()
	If $SortList = 1 Then
		$SortList = 0
	Else
		$SortList = 1
		$sort_timer = TimerInit()
	EndIf
EndFunc   ;==>_AutoSort


Func _GpsToggle()
	If $ScanGPS = 1 Then
		$ScanGPS = 0
		_CloseComPort(GUICtrlRead($ComPort)) ;Close The GPS COM port
	Else
		$ScanGPS = 1
		_OpenComPort(GUICtrlRead($ComPort), GUICtrlRead($BAUD));Open The GPS COM port
	EndIf
EndFunc   ;==>_GpsToggle

Func ScanToggle()
	If $Scan = 1 Then
		$Scan = 0
		GUICtrlSetData($ScanButton, "Scan")
	Else
		$Scan = 1
		GUICtrlSetData($ScanButton, "Stop")
	EndIf
EndFunc   ;==>ScanToggle

Func CLOSEClicked()
	FileDelete($tempfile)
	IniWrite($settings, 'Vistumbler', 'ComPort', GUICtrlRead($ComPort))
	IniWrite($settings, 'Vistumbler', 'Baud', GUICtrlRead($BAUD))
	IniWrite($settings, 'Vistumbler', 'Sleeptime', GUICtrlRead($sleeptime))
	IniWrite($settings, 'Vistumbler', 'AutoSortTime', GUICtrlRead($AutoSortTime))
	IniWrite($settings, 'Vistumbler', 'SortCombo', GUICtrlRead($SortCombo))
	IniWrite($settings, 'Vistumbler', 'AscDecDefault', GUICtrlRead($SortAscDec))
	IniWrite($settings, 'Vistumbler', 'AutoSort', GUICtrlRead($AutoSort))
	IniWrite($settings, 'Vistumbler', 'PlaySoundOnNewAP', GUICtrlRead($PlaySound))

	If $ScanGPS = 1 Then ;If GPS is active, stop it so the COM port does not stay open
		_GpsToggle()
		Exit
	Else
		Exit
	EndIf
EndFunc   ;==>CLOSEClicked

Func SaveList()
	$timestamp = @MON & '-' & @MDAY & '-' & @YEAR & ' ' & @HOUR & '-' & @MIN & '-' & @SEC
	$file = FileSaveDialog("Output File", @ScriptDir, 'Text (*.txt)', '', $timestamp & '.txt')
	If @error <> 1 Then
		If StringInStr($file, '.txt') = 0 Then $file = $file & '.txt'
		For $save = 0 To _GUICtrlListViewGetItemCount($AccessPointList) - 1
			GUICtrlSetData($msgdisplay, 'Saving Line ' & $save & ' / ' & _GUICtrlListViewGetItemCount($AccessPointList))
			FileWriteLine($file, _GUICtrlListViewGetItemText($AccessPointList, $save, $column_SSID) & '|' & _GUICtrlListViewGetItemText($AccessPointList, $save, $column_BSSID) & '|' & _GUICtrlListViewGetItemText($AccessPointList, $save, $column_MANUF) & '|' & _GUICtrlListViewGetItemText($AccessPointList, $save, $column_Signal) & '|' & _GUICtrlListViewGetItemText($AccessPointList, $save, $column_Authentication) & '|' & _GUICtrlListViewGetItemText($AccessPointList, $save, $column_Encryption) & '|' & _GUICtrlListViewGetItemText($AccessPointList, $save, $column_RadioType) & '|' & _GUICtrlListViewGetItemText($AccessPointList, $save, $column_Channel) & '|' & _GUICtrlListViewGetItemText($AccessPointList, $save, $column_Latitude) & '|' & _GUICtrlListViewGetItemText($AccessPointList, $save, $column_Longitude) & '|' & _GUICtrlListViewGetItemText($AccessPointList, $save, $column_BasicTransferRates) & '|' & _GUICtrlListViewGetItemText($AccessPointList, $save, $column_OtherTransferRates) & '|' & _GUICtrlListViewGetItemText($AccessPointList, $save, $column_FirstActive) & '|' & _GUICtrlListViewGetItemText($AccessPointList, $save, $column_LastActive) & '|' & _GUICtrlListViewGetItemText($AccessPointList, $save, $column_NetworkType))
		Next
		MsgBox(0, 'Done', 'Saved as: "' & $file & '"')
		GUICtrlSetData($msgdisplay, '')
	EndIf
EndFunc   ;==>SaveList

Func LoadList()
	$file = FileOpenDialog("Output File", @ScriptDir, 'Text (*.txt)')
	If @error <> 1 Then
		If StringInStr($file, '.txt') = 0 Then $file = $file & '.txt'
		_FileReadToArray($file, $OpenArray)
		For $open = 1 To $OpenArray[0] - 1
			GUICtrlSetData($msgdisplay, 'Loading Line ' & $open & ' / ' & $OpenArray[0] - 1)
			$loadlist = StringSplit($OpenArray[$open], '|')
			If IsArray($loadlist) Then
				Dim $SSID = '', $NetworkType = '', $Authentication = '', $Encryption = '', $BSSID = '', $Signal = '', $RadioType = '', $Channel = '', $BasicTransferRates = '', $OtherTransferRates = '', $LoadLatitude = '', $LoadLongitude = '', $FirstActive = '', $LastActive = '', $MANUF = '';Clear Variables

				$SSID = StringStripWS($loadlist[1], 3)
				$BSSID = StringStripWS($loadlist[2], 3)
				If $loadlist[3] <> 'Unknown' Then $MANUF = StringStripWS($loadlist[3], 3)
				$Signal = StringStripWS($loadlist[4], 3)
				$Authentication = StringStripWS($loadlist[5], 3)
				$Encryption = StringStripWS($loadlist[6], 3)
				$RadioType = StringStripWS($loadlist[7], 3)
				$Channel = StringStripWS($loadlist[8], 3)
				$LoadLatitude = StringStripWS($loadlist[9], 3)
				$LoadLongitude = StringStripWS($loadlist[10], 3)
				$BasicTransferRates = StringStripWS($loadlist[11], 3)
				$OtherTransferRates = StringStripWS($loadlist[12], 3)
				$FirstActive = StringStripWS($loadlist[13], 3)
				$LastActive = StringStripWS($loadlist[14], 3)
				$NetworkType = StringStripWS($loadlist[15], 3)
				
				If $BSSID <> '' Then ; If Mac Address(BSSID) was found write data into
					$arraysearch = -1
					$itemcount = _GUICtrlListViewGetItemCount($AccessPointList)
					For $findloop = 0 To $itemcount; Find BSSID in existing list
						If _GUICtrlListViewGetItemText($AccessPointList, $itemcount - $findloop, $column_BSSID) = $BSSID And $SSID <> '' Then
							$arraysearch = $itemcount - $findloop
							ExitLoop
						EndIf
					Next
					If $arraysearch = -1 Then ;If BSSID is not found, add it - Else - Update old entry
						$new = _GUICtrlListViewInsertItem($AccessPointList, -1, '')
						_GUICtrlListViewSetItemText($AccessPointList, $new, $column_Active, '')
						_GUICtrlListViewSetItemText($AccessPointList, $new, $column_SSID, $SSID)
						_GUICtrlListViewSetItemText($AccessPointList, $new, $column_BSSID, $BSSID)
						_GUICtrlListViewSetItemText($AccessPointList, $new, $column_MANUF, $MANUF)
						_GUICtrlListViewSetItemText($AccessPointList, $new, $column_Signal, $Signal)
						_GUICtrlListViewSetItemText($AccessPointList, $new, $column_Authentication, $Authentication)
						_GUICtrlListViewSetItemText($AccessPointList, $new, $column_Encryption, $Encryption)
						_GUICtrlListViewSetItemText($AccessPointList, $new, $column_RadioType, $RadioType)
						_GUICtrlListViewSetItemText($AccessPointList, $new, $column_Channel, $Channel)
						_GUICtrlListViewSetItemText($AccessPointList, $new, $column_Latitude, $LoadLatitude)
						_GUICtrlListViewSetItemText($AccessPointList, $new, $column_Longitude, $LoadLongitude)
						_GUICtrlListViewSetItemText($AccessPointList, $new, $column_BasicTransferRates, $BasicTransferRates)
						_GUICtrlListViewSetItemText($AccessPointList, $new, $column_OtherTransferRates, $OtherTransferRates)
						_GUICtrlListViewSetItemText($AccessPointList, $new, $column_FirstActive, $FirstActive)
						_GUICtrlListViewSetItemText($AccessPointList, $new, $column_LastActive, $LastActive)
						_GUICtrlListViewSetItemText($AccessPointList, $new, $column_NetworkType, $NetworkType)
					Else
						_GUICtrlListViewSetItemText($AccessPointList, $arraysearch, $column_Active, "")
						_GUICtrlListViewSetItemText($AccessPointList, $arraysearch, $column_SSID, $SSID)
						_GUICtrlListViewSetItemText($AccessPointList, $arraysearch, $column_BSSID, $BSSID)
						;_GUICtrlListViewSetItemText($AccessPointList, $arraysearch, $column_MANUF, $MANUF)
						_GUICtrlListViewSetItemText($AccessPointList, $arraysearch, $column_Signal, $Signal)
						_GUICtrlListViewSetItemText($AccessPointList, $arraysearch, $column_Authentication, $Authentication)
						_GUICtrlListViewSetItemText($AccessPointList, $arraysearch, $column_Encryption, $Encryption)
						_GUICtrlListViewSetItemText($AccessPointList, $arraysearch, $column_RadioType, $RadioType)
						_GUICtrlListViewSetItemText($AccessPointList, $arraysearch, $column_Channel, $Channel)
						_GUICtrlListViewSetItemText($AccessPointList, $arraysearch, $column_Latitude, $LoadLatitude)
						_GUICtrlListViewSetItemText($AccessPointList, $arraysearch, $column_Longitude, $LoadLongitude)
						_GUICtrlListViewSetItemText($AccessPointList, $arraysearch, $column_BasicTransferRates, $BasicTransferRates)
						_GUICtrlListViewSetItemText($AccessPointList, $arraysearch, $column_OtherTransferRates, $OtherTransferRates)
						_GUICtrlListViewSetItemText($AccessPointList, $arraysearch, $column_FirstActive, $FirstActive)
						_GUICtrlListViewSetItemText($AccessPointList, $arraysearch, $column_LastActive, $LastActive)
						_GUICtrlListViewSetItemText($AccessPointList, $arraysearch, $column_NetworkType, $NetworkType)
					EndIf
				EndIf
			EndIf
		Next
		MsgBox(0, 'Done', 'Load of file: "' & $file & '" complete')
		GUICtrlSetData($msgdisplay, '')
	EndIf
EndFunc   ;==>LoadList

Func SaveToKML()
	$timestamp = @MON & '-' & @MDAY & '-' & @YEAR & ' ' & @HOUR & '-' & @MIN & '-' & @SEC
	$kml = FileSaveDialog("Google Earth Output File", @ScriptDir, 'Google Earth (*.kml)', '', $timestamp & '.kml')
	If @error <> 1 Then
		If StringInStr($kml, '.kml') = 0 Then $kml = $kml & '.kml'
		FileDelete($kml)
		$file = '<?xml version="1.0" encoding="utf-8"?>' & @CRLF _
				 & '<kml xmlns="http://earth.google.com/kml/2.0">' & @CRLF _
				 & '<Document>' & @CRLF _
				 & '<Style id="secureStyle">' & @CRLF _
				 & '<IconStyle>' & @CRLF _
				 & '<scale>.5</scale>' & @CRLF _
				 & '<Icon>' & @CRLF _
				 & '<href>http://mboffin.com/earthstumbler/wap-secure.png</href>' & @CRLF _;image from EarthStubler
				 & '</Icon>' & @CRLF _
				 & '</IconStyle>' & @CRLF _
				 & '</Style>' & @CRLF _
				 & '<Style id="openStyle">' & @CRLF _
				 & '<IconStyle>' & @CRLF _
				 & '<scale>.5</scale>' & @CRLF _
				 & '<Icon>' & @CRLF _
				 & '<href>http://mboffin.com/earthstumbler/wap-open.png</href>' & @CRLF _;image from EarthStubler
				 & '</Icon>' & @CRLF _
				 & '</IconStyle>' & @CRLF _
				 & '</Style>' & @CRLF _
				 & '<Folder>' & @CRLF _
				 & '<description>Vistumbler - By Andrew Calcutt</description>' & @CRLF _
				 & '<name>NetstublerToKML</name>' & @CRLF _
				 & '<Folder>' & @CRLF _
				 & '<name>Access Points</name>' & @CRLF _
				 & '<description>Access points found</description>' & @CRLF
		
		
		For $i = 0 To _GUICtrlListViewGetItemCount($AccessPointList) - 1
			GUICtrlSetData($msgdisplay, 'Saving Line ' & $i & ' / ' & _GUICtrlListViewGetItemCount($AccessPointList))
			If _GUICtrlListViewGetItemText($AccessPointList, $i, $column_Latitude) <> '' And _GUICtrlListViewGetItemText($AccessPointList, $i, $column_Latitude) <> 'N 0.0000000' Then
				$file &= '<Placemark>' & @CRLF _
						 & '<name></name>' & @CRLF _
						 & '<description><![CDATA[<b>SSID: </b>' & _GUICtrlListViewGetItemText($AccessPointList, $i, $column_SSID) & '<br /><b>BSSID: </b>' & _GUICtrlListViewGetItemText($AccessPointList, $i, $column_BSSID) & '<br /><b>Network Type: </b>' & _GUICtrlListViewGetItemText($AccessPointList, $i, $column_NetworkType) & '<br /><b>Radio Type: </b>' & _GUICtrlListViewGetItemText($AccessPointList, $i, $column_RadioType) & '<br /><b>Channel: </b>' & _GUICtrlListViewGetItemText($AccessPointList, $i, $column_Channel) & '<br /><b>Authentication: </b>' & _GUICtrlListViewGetItemText($AccessPointList, $i, $column_Authentication) & '<br /><b>Encryption: </b>' & _GUICtrlListViewGetItemText($AccessPointList, $i, $column_Encryption) & '<br /><b>Basic Rates: </b>' & _GUICtrlListViewGetItemText($AccessPointList, $i, $column_BasicTransferRates) & '<br /><b>Other Rates: </b>' & _GUICtrlListViewGetItemText($AccessPointList, $i, $column_OtherTransferRates) & '<br /><b>First Seen: </b>' & _GUICtrlListViewGetItemText($AccessPointList, $i, $column_FirstActive) & '<br /><b>Last Seen: </b>' & _GUICtrlListViewGetItemText($AccessPointList, $i, $column_LastActive) & '<br /><b>Signal: </b>' & _GUICtrlListViewGetItemText($AccessPointList, $i, $column_Signal) & '<br /><b>Latitude: </b>' & _GUICtrlListViewGetItemText($AccessPointList, $i, $column_Latitude) & '<br /><b>Longitude: </b>' & _GUICtrlListViewGetItemText($AccessPointList, $i, $column_Longitude) & '<br /><b>Manufacturer: </b>' & _GUICtrlListViewGetItemText($AccessPointList, $i, $column_MANUF) & '<br />]]></description>'
				If _GUICtrlListViewGetItemText($AccessPointList, $i, $column_Authentication) = "Open" And _GUICtrlListViewGetItemText($AccessPointList, $i, $column_Encryption) = "None" Then
					$file &= '	<styleUrl>#openStyle</styleUrl>' & @CRLF
				Else
					$file &= '	<styleUrl>#secureStyle</styleUrl>' & @CRLF
				EndIf
				
				$file &= '<Point>' & @CRLF _
						 & '<coordinates>' & StringReplace(StringReplace(StringReplace(_GUICtrlListViewGetItemText($AccessPointList, $i, $column_Longitude), 'W', '-'), 'E', ''), ' ', '') & ',' & StringReplace(StringReplace(StringReplace(_GUICtrlListViewGetItemText($AccessPointList, $i, $column_Latitude), 'S', '-'), 'N', ''), ' ', '') & ',0</coordinates>' & @CRLF _
						 & '</Point>' & @CRLF _
						 & '</Placemark>' & @CRLF
			EndIf
		Next
		
		$file &= '</Folder>' & @CRLF _
				 & '</Folder>' & @CRLF _
				 & '</Document>' & @CRLF _
				 & '</kml>' & @CRLF
		
		;MsgBox(0, '', $file)
		
		FileWrite($kml, $file)
		MsgBox(0, 'Done', 'Saved as: "' & $kml & '"')
		GUICtrlSetData($msgdisplay, '')
	EndIf
EndFunc   ;==>SaveToKML